# SIMCA-Q Samples

This folder contains examples that shows how to use SIMCA-Q in different development environments.

The samples are organized in sub folders per programming language: 

* C
* C++
* COM
* Python
* C#
* Visual Basic
  
Some folders contains many examples. Learn more about each example in its readme.txt file.

## Using samples from Windows with Visual Studio 2022

How to get started:

* Each sub folder contains a Visual Studio `.vcxproj` file that you open in Visual Studio.

* Build the project in Visual Studio. The output are placed in a `output` sub folder.
  * If the build fails, you might have installed SIMCA-Q in a non-default location. If so,
    edit the `SIMCA-Q-samples.props` file and specify the location of SIMCA-Q there (see comments in that file).

* You cannot run the built executables directly by double-clicking an executable in the output folder, because
  the file won't be able to locate your installed SIMCA-Q files.
  * To fix this you can add SIMCA-Q's program folder to your PATH variable. Or you can create a Windows shortcut to the sample executable file and,
    in the shortcut's properties, set the 'Start in' directory to the `lib` folder in SIMCA Q's program folder.

* Debug the code from Visual Studio. Visual Studio will be able to find the SIMCA-Q files because the
  project configuration in Visual Studio points to the location of the files.

## Using samples from Linux

The Linux distribution uses the same source code for the C and C++ demos, but how you build and run them is different in Linux. Learn more in separate readmes that are included in the Linux package.
